/*
    The main function of "Jenny Thinks"
*/

#include "video.h"
#include "kokko.h"
#include "mosaic.h"
#include "maf.h"
#include "noise.h"
#include "blox.h"
#include "halftone.h"
#include "filmi.h"
#include "tunneli.h"
#include "texts.h"

#include "data.h"

#ifdef GP32
#include <gpstdio.h>
#include <gpstdlib.h>
#include <gpgraphic.h>
#include <gpfont.h>
#include <gpmodplay.h>
#else
#include "cool_mzx/cool_mzx.h"
#endif

#include <SDL/SDL.h>

#include <stdio.h>
#include <string.h>
#include <math.h>

unsigned char buf[320*200],buf2[320*200];
unsigned char *displaybuf=buf,*nc;

extern char formula3[];


#ifndef TRUE8BIT
static unsigned lockup[256];
#endif

void burnpalette(SDL_Surface *s,int kerroin, int nollakohta)
{   
    int i,c;
#ifdef GP32
    GP_PALETTEENTRY entry;
#else
    static SDL_Color pal[256];
#endif
   
    for (i=0; i<256; i++) {
        
        c=i*kerroin-nollakohta;
        if (c>255)
            c=255;
        if (c<0)
            c=0;

#ifdef GP32
        c>>=3;
        entry=(c<<11)+(c<<6)+(c<<1)+1;
        GpPaletteEntryChange(i,1,&entry,0);
#else
#ifdef TRUE8BIT
        pal[i].r=c;
        pal[i].g=c;
        pal[i].b=c;
#else
        lockup[i]=(c<<16)+(c<<8)+c;
#endif
#endif
   }

#ifndef GP32
#ifdef TRUE8BIT
   SDL_SetPalette(s,SDL_LOGPAL,pal,0,256);
#endif
#endif
}


// triggers
#define SCRATCH 1
#define RESTART 2
#define CLEAR_OLD 4
#define SPEED_UP 8
#define ADD 16

// effects
#define FILM 1
#define BLUR 2
#define HALFTONE 4
#define BLOX 8
#define MAF 16

#define V_AUTO 0
#define V_JENNY 1
#define V_STRIKING 2
#define V_AD 3
#define V_KAANTO 4
#define V_UKKO 5
#define V_NAINEN 6
#define V_MEAT 7
#define V_BEER 8
#define V_FINGER 9

#define V_NONE 32

#define VOLLY 16

// how many columns in the osa array
#define N 6

#define BEAT 0
#define CLIP_N 1
#define CLIP_SPD 2
#define TRIGGERS 3
#define EFFECTS 4
#define PARAM 5

#define TEXT_N 1
#define TEXT_X 2
#define TEXT_Y 3

/*
enum {T_JENNY=0,T_FIT,T_BW,T_YEAAH,T_MARQ,T_NF,T_ROZ,T_PETE,T_POPULARITY,
      T_BOYS,T_MISS};
      */

#define TN 4
int tekstit[]={
    // beat, text_n,x,y
    000, T_NONE,100,5,
    100, T_BW, 100, 5,
    132,T_FIT, 100, 5,
    200,T_NONE,100,5,
    400,T_MARQ,15,170,
    431,T_ROZ,15,170,
    500,T_MARQ,15,170,
    531,T_ROZ,15,170,
    600,T_NF,180,115,
    631,T_ROZ,15,170,
    700,T_NF,180,115,
    731,T_MARQ,15,170,
    800,T_NONE,0,0,

    838,T_MISS,50,0,
    848,T_NONE,0,0,

    938,T_MISS,50,0,
    948,T_NONE,0,0,

    1000,T_JENNY,0,0,
    1012,T_POPULARITY,150,0,
    1032,T_NONE,150,0,
    1042,T_BOYS,100,20,

    1100,T_JENNY,0,0,
    1112,T_POPULARITY,100,20,
    1132,T_NONE,100,20,
    1142,T_BOYS,100,20,
    1200,T_NONE,0,0,

    1438,T_MISS,50,0,
    1448,T_NONE,0,0,

    1538,T_MISS,50,0,
    1548,T_NONE,0,0,

    1600,T_JENNY,0,0,
    1612,T_POPULARITY,150,0,
    1632,T_NONE,150,0,
    1642,T_BOYS,100,20,

    1700,T_JENNY,0,0,
    1702,T_JENNY,40,40,
    1704,T_JENNY,80,0,
    1712,T_POPULARITY,100,20,
    1732,T_NONE,100,20,
    1742,T_BOYS,100,20,
    1700,T_NONE,0,0,

};

// 0, 3, 8, 11, 13
int osat[]={
    // beat, clip #, clip spd,triggers, param1

    00,  V_MEAT,20,0,0,0,
    100, V_MEAT,10,0,0,0,
    148, V_MEAT,20,SCRATCH,0,0,

    200, VOLLY|V_STRIKING,100,0,0,10,
    232, VOLLY|V_AD,100,0,0,40,

    300, VOLLY|V_STRIKING,200,0,0,100,
    332, V_KAANTO,100,0,FILM,-100,
    348, V_KAANTO,10,0,FILM,100,
    360, V_KAANTO,400,0,FILM,0,

    400, V_UKKO,80,0,0,0,
    431, V_BEER,80,CLEAR_OLD,0,0,
    440, V_BEER,80,0,BLUR,0,

    500, V_UKKO,100,0,0,120,
    502, V_UKKO,100,SCRATCH,0,80,
    516, V_UKKO,50,SCRATCH,0,50,
    532, V_BEER,100,0,0,40,
    534, V_BEER,100,SCRATCH,0,50,
    560, V_BEER,150,SCRATCH,0,80,

    600, V_NAINEN,60,0,0,0,
    631, V_BEER,50,CLEAR_OLD,0,0,
    640, V_BEER,80,0,BLUR,0,
    700, V_NAINEN,100,0,0,1,
    731, V_UKKO,50,0,0,120,

    800, V_MEAT,100,0,FILM,100,
    816, V_MEAT,100,SCRATCH,MAF,-100,
    832, V_MEAT,100,SCRATCH,FILM,100,

    916, V_MEAT,100,SCRATCH,MAF,-100,
    932, V_MEAT,100,0,FILM,100,
    948, V_MEAT,400,0,0,100,
    956, V_MEAT,50,0,0,100,

    1000,V_JENNY,80,0,0,0,
    1032,V_AUTO,200,RESTART,0,0,
    1044,V_AUTO,200,SCRATCH,0,0,
    1056,V_AUTO,50,SCRATCH,0,0,

    1100,V_JENNY,80,0,0,0,
    1101,V_JENNY,80,RESTART,0,0,
    1102,V_JENNY,80,RESTART,0,0,
    1103,V_JENNY,80,RESTART,0,0,
    1132,V_AUTO,200,RESTART,0,0,
    1133,V_AUTO,200,RESTART,0,0,
    1134,V_AUTO,200,RESTART,0,0,
    1135,V_AUTO,200,RESTART,0,0,
    1136,V_AUTO,200,RESTART,0,0,
    1140,V_AUTO,200,SCRATCH,0,0,
    1156,V_AUTO,50,SCRATCH,0,0,

    1200, VOLLY|V_BEER,80,0,0,100,
    1231, VOLLY|V_UKKO,80,0,0,20,
    1240, VOLLY|V_UKKO,80,0,0,100,
    1242, VOLLY|V_UKKO,80,0,0,20,
    1244, VOLLY|V_UKKO,80,0,0,100,

    1300, VOLLY|V_BEER,100,0,0,0,
    1302, VOLLY|V_BEER,100,SCRATCH,0,0,
    1316, VOLLY|V_BEER,50,SCRATCH,0,0,
    1332, VOLLY|V_UKKO,100,0,0,0,
    1334, VOLLY|V_UKKO,100,SCRATCH,0,0,
    1360, VOLLY|V_UKKO,150,SCRATCH,0,0,

    1400, VOLLY|V_FINGER,100,0,0,100,
    1416, V_FINGER,100,0,MAF,-100,
    1432, VOLLY|V_FINGER,100,0,0,100,

    1500, VOLLY|V_FINGER,100,0,0,100,
    1516, V_FINGER,100,0,MAF,-100,
    1532, VOLLY|V_FINGER,100,0,0,100,

    1600,V_JENNY,80,ADD,BLOX,0,
    1632,V_AUTO,50,RESTART,BLOX,0,
    1648,V_AUTO,50,SCRATCH,BLOX,0,
    1656,V_AUTO,200,SCRATCH,BLOX,0,

    1700,V_JENNY,80,0,BLOX,0,
    1701,V_JENNY,80,RESTART,BLOX,0,
    1702,V_JENNY,80,RESTART,BLOX,0,
    1703,V_JENNY,80,RESTART,BLOX,0,
    1732,V_AUTO,150,RESTART,BLOX,0,
    1733,V_AUTO,150,RESTART,BLOX,0,
    1734,V_AUTO,150,RESTART,BLOX,0,
    1735,V_AUTO,150,RESTART,BLOX,0,
    1736,V_AUTO,150,RESTART,BLOX,0,
    1740,V_AUTO,150,SCRATCH,BLOX,0,

    1800,V_AUTO,150,SCRATCH|SPEED_UP,FILM,10,
};

#ifdef GP32
void GpMain(void *argv)
#else
int main(int argc,char **argv)
#endif
{
    int modpos,quit=0,frame=0,n,i;
    int video_trig,vbl,vbl2,origtick;

    int osa_pos;
    int clip_n;

    int scratched_row=-1;
    int restarted_row=-1;

    float param1;
    int e1on=0;
    int e2on=0;
    int e3on=0;
    int e4on=0;
    int e5on=0;
    float video_spd=0.5;
    int trigger;
    int volly_on=0;
    int speed_up_start=0;

    int angle;
    int alkutikki,tikki,tikki2,first=1;
    int dt=0,dt2=0;
    int ovbl=0;

    int text_pos=0;
    int text_n;
    int text_x;
    int text_y;

    int volly_pos=0;

    int nv=0;
    int video_on=1;

    int blox_intensity_vbl=0;

    SDL_Event e;
    SDL_Surface *s;
#ifdef TRUE8BIT
    char *screen;
#else
    unsigned *screen;
#endif
    int flags=SDL_SWSURFACE+SDL_FULLSCREEN;

#ifdef GP32
    MODPlay a;

    GpClockSpeedChange(132000000,0x3a011,3);
    nc=(unsigned char *)(0x0C7B4000+320*256);
    swi_mmu_change(nc,nc+320*256-1,0xFF2);
#endif

#ifndef GP32
    if(argc==2)
        if(!strcmp(argv[1],"-w"))
            flags-=SDL_FULLSCREEN;
    if(argv[0][strlen(argv[0])-1]=='w')
        flags-=SDL_FULLSCREEN;
#endif

    init_filter();
    init_maf();
    mosaic_init(40);
    halftone_init(320,200);
    init_tunneli();

    SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER);

#ifndef GP32
    ungetc('\n',stdin);
    ungetc('2',stdin);
    mzx_init();
    mzx_get(formula3);
#endif

#ifdef GP32
    s=SDL_SetVideoMode(320,240,8,flags);
    screen=s->pixels;
#else
#ifdef TRUE8BIT
    s=SDL_SetVideoMode(640,480,8,flags);
#else
    s=SDL_SetVideoMode(640,480,32,flags);
#endif
    SDL_WM_SetCaption("GP32 stuff by Bandwagon & Fit",NULL);
    SDL_ShowCursor(0);
    screen=s->pixels;
#ifdef TRUE8BIT
    memset(s->pixels,0,640*480);
#else
    memset(s->pixels,0,640*480*4);
#endif
#endif
    burnpalette(s,1,0);

#ifdef GP32
    MODPlay_Init(&a);
    MODPlay_SetMOD(&a,formula3);
    a.mod.musicvolume=a.mod.sfxvolume=48;
    a.playfreq=44100;
    a.numSFXChannels=0;
    a.soundBuf.samples=4096;
    a.soundBuf.pollfreq=43;
    MODPlay_SetPlayFreq(&a,44100);
    MODPlay_Start(&a);
#else
    mzx_start(41);
    while(mzx_position()<0 || mzx_position()>100) // Skip a bug...
        ;
#endif

#ifdef GP32 // SDL_GetTicks is disturbed because of the clock speed
#define TICK_K 0.62
#else
#define TICK_K 1.0
#endif

    origtick=SDL_GetTicks()*TICK_K;
    vbl2=0;

#ifdef GP32
    filter_kokko(&buf[0], 0,256,0,0);
#endif

    /* The main loop */
    while(!quit)
    {

	vbl=(SDL_GetTicks()*TICK_K-origtick)/20;
        if(vbl<=vbl2+1)
            goto toofast;
	vbl2=vbl;

#ifdef GP32
        modpos=a.mod.songpos*100+a.mod.patternline;
#else
        modpos=mzx_position();
#endif

	if (modpos>1840)
	    quit=1;

        osa_pos=-1;
	for (i=0; i<(sizeof(osat)/4)/N; i++)
	    if (modpos>=osat[i*N+BEAT])
		osa_pos=i;

	text_pos=-1;
	for (i=0; i<(sizeof(tekstit)/4)/TN; i++)
	    if (modpos>=tekstit[i*TN+BEAT])
		text_pos=i;

        /* Text parameters from the array */
	text_n=tekstit[text_pos*TN+TEXT_N];
	text_x=tekstit[text_pos*TN+TEXT_X];
	text_y=tekstit[text_pos*TN+TEXT_Y];

        /* Video and effect parameters */
	volly_on=osat[osa_pos*N+CLIP_N] & 16;
	video_on=32-(osat[osa_pos*N+CLIP_N] & 32);

	clip_n=osat[osa_pos*N+CLIP_N] % 16;
	video_spd=(float)osat[osa_pos*N+CLIP_SPD]/100.0;
	trigger=osat[osa_pos*N+TRIGGERS];
	param1=(float)osat[osa_pos*N+PARAM]/100.0;

	e1on=((osat[osa_pos*N+EFFECTS] & BLUR)==BLUR);
	e2on=((osat[osa_pos*N+EFFECTS] & MAF)==MAF);
	e3on=((osat[osa_pos*N+EFFECTS] & BLOX)==BLOX);
	e4on=((osat[osa_pos*N+EFFECTS] & FILM)==FILM);

	if ((trigger & ADD) && (osa_pos!=restarted_row))  {
            blox_intensity_vbl=vbl;
	    restarted_row=osa_pos;
	}
	if ((trigger & SPEED_UP) && (osa_pos!=restarted_row))  {
            speed_up_start=vbl;
	    restarted_row=osa_pos;
	}
	if ((trigger & CLEAR_OLD) && (osa_pos!=restarted_row))  {
	    clear_old_kokko();
	    restarted_row=osa_pos;

	}
	if ((trigger & RESTART) && (osa_pos!=restarted_row)) {
	    video_zero_frame(&videot[clip_n % nvid]);
	    restarted_row=osa_pos;
	}

	if ((trigger & SCRATCH) && (osa_pos!=scratched_row)) {
	    video_turn_direction();
	    scratched_row=osa_pos;
	}

        /* The original VJ style controls */
	while(SDL_PollEvent(&e)>0)
        {
            if(e.type==SDL_MOUSEBUTTONDOWN)
                quit=1;
	    if(e.type==SDL_KEYDOWN)
		switch (e.key.keysym.sym) {
		case SDLK_SPACE:
                    video_turn_direction();
		    break;
		case SDLK_RETURN:
		    video_zero_frame(&videot[clip_n % nvid]);
                    break;
		case SDLK_F1:
                    e1on=(e1on+1) % 4;
                    break;
		case SDLK_F2:
                    e2on=(e2on+1) % 4;
                    break;
		case SDLK_F3:
                    e3on=(e3on+1) % 3;
                    break;
		case SDLK_F4:
                    e4on=(e4on+1) % 2;
                    break;
		case SDLK_DOWN:
                    if (video_spd>0.0)
			video_spd-=0.05;
                    break;
		case SDLK_UP:
                    video_spd+=0.05;
                    break;
		case SDLK_TAB:
		    nv++;
                    break;
		case SDLK_ESCAPE:
		    quit=1;
                    break;
		default:
		    break;
		}
        }

        /* Run the video unpacker and effects */
	if (volly_on) {
	    tunneli(&buf[0],vbl,param1*100);
	}

	set_video_spd(video_spd);

        if (video_on)
	    show_video(&buf[0],&videot[clip_n % nvid],vbl*20,16-volly_on);

	if (text_n!=T_NONE) {
	    text_put(displaybuf,text_x,text_y,text_n,vbl);
	}

	if (e2on) {
	    vert_maf(buf,buf2,0,0,0,0,320,200,320,200,
		      sin(vbl*0.03)*25+25+10);

	    memcpy(buf,buf2,sizeof(buf));
	}

	if (e1on==1) {
	    filter_kokko(&displaybuf[0], vbl,250,0,0);
	} else if (e1on==2) {
	    filter_kokko(&displaybuf[0], vbl,245,0,0);
	} else if (e1on==3) {
	    filter_kokko(&displaybuf[0], vbl,250,1,0);
	}

	if (e3on==1)
	    blox((unsigned char *)&buf, 20,
		 0+(float)(vbl-blox_intensity_vbl)*0.50,
		 0+(float)(vbl-blox_intensity_vbl)*0.12);

        else if (e3on==2)
	    blox((unsigned char *)&buf, 32, 244, 0);

	noise((unsigned char *)&buf, vbl);

	if (e4on) {
#ifdef GP32
            nc=(unsigned char *)(0x0C7B4000+320*256);
	    if (trigger & SPEED_UP) {
		filmi(nc,buf,40000+(float)pow(vbl-speed_up_start,1.7)*0.015*param1);
	    } else {
		filmi(nc,buf,40000+(float)vbl*0.015*param1);
	    }
	    displaybuf=nc;
#else
	    if (trigger & SPEED_UP) {
		filmi(buf2,buf,40000+(float)pow(vbl-speed_up_start,1.7)*0.015*param1);
	    } else {
		filmi(buf2,buf,40000+(float)vbl*0.015*param1);
	    }
	    displaybuf=buf2;
#endif
	}

        frame++;
        SDL_LockSurface(s);
        
#ifdef GP32
        /*  The original method:
            memcpy(&screen[20*320],displaybuf,320*200);
            SDL_Flip(s);

            Now using the very own synced blit kludge:
        */
#define rLCDCON1 (*(volatile unsigned *)0x14a00000)
        while ((rLCDCON1>>18)>100);

        screen=(unsigned char *)0x0C7B4000;
        for(n=0;n<320;n++)
        {
            unsigned char *tmp=&screen[n*240+20+200];
            for(i=0;i<200*320;)
            {
                *tmp--=displaybuf[n+i];
                i+=320;
                *tmp--=displaybuf[n+i];
                i+=320;
                *tmp--=displaybuf[n+i];
                i+=320;
                *tmp--=displaybuf[n+i];
                i+=320;
            }
        }
#else
        screen=s->pixels;
        for(n=0;n<200;n++)
        {
#ifdef TRUE8BIT
            unsigned char *p=&screen[(n+20)*640*2];
            for(i=0;i<320;i++,p+=2)
                *p=*(p+1)=displaybuf[n*320+i];
            for(i=0;i<320;i++,p+=2)
                *p=*(p+1)=*(p-640)>>1;
#else
            unsigned *p=&screen[(n+20)*640*2];
            for(i=0;i<320;i++,p+=2)
                *p=*(p+1)=lockup[displaybuf[n*320+i]];
            for(i=0;i<320;i++,p+=2)
                *p=*(p+1)=(*(p-640)>>1)&0x7f7f7f;
#endif
        }
        SDL_UnlockSurface(s);
        SDL_Flip(s);
#endif

        toofast:
        displaybuf=buf;
    }

    SDL_Quit();
#ifdef GP32
    asm("mov        r3,#0; bx       r3;");
#else
    return(0);
#endif
}
